/*
 * Proyecto: BrowseMod
 * Fichero: Form1.prg
 * Descripcin:
 * Autor:
 * Fecha: 14/11/2021
 */

#include "Xailer.ch"

CLASS TForm1 FROM TForm

   COMPONENT oPanel1
   COMPONENT oBrowseMod1

   METHOD CreateForm()
   METHOD FormInitialize( oSender )
   METHOD BrowseMod1KeyDown( oSender, nKey, nFlags )
   METHOD BrowseMod1SaveCol( oSender, oCol, xValue )

ENDCLASS

#include "Form1.xfm"

#define Campos_aInsertLineBrow      {"","",0}

//------------------------------------------------------------------------------

METHOD FormInitialize( oSender ) CLASS TForm1
   ::oBrowseMod1:aGridData := {Campos_aInsertLineBrow,Campos_aInsertLineBrow}
RETURN Nil

//------------------------------------------------------------------------------

METHOD BrowseMod1KeyDown( oSender, nKey, nFlags ) CLASS TForm1
   Local oCol := oSender:oSelectCol, nRegistro := 0
   Local cKey := "",nId,lCorrecto, nColActual := oSender:nSelectCol

   If nKey == VK_RETURN
      oSender:GoRight()
      If nColActual >=  Len( oSender:aCols )
         oSender:GoLeftMost()
         nRegistro := oSender:nIndex
         oSender:GoDown() //Baja en una unidad la actual fila del browse
         oSender:nSelectCol := 1
         If oSender:nIndex > Len(::oBrowseMod1:aGridData) //nRegistro  // Si no me puedo mover de registro es que estoy al final
            PostMessage(oSender:Handle, WM_KEYDOWN, VK_INSERT,VK_CONTROL)
            RETURN 0
         EndIf
      EndIf

   ElseIf nKey == VK_INSERT .AND. (lGetKeyState( VK_CONTROL ) .OR. nFlags == VK_CONTROL) .AND. !oSender:IsOnEdit()
      //If oSender:aGridData[ oSender:nIndex, oCol:nDataCol ] == Nil .OR. !Empty(oSender:aGridData[ oSender:nIndex, oCol:nDataCol ])// Si campo Articulo esta vacio no hace falta insertar liena
         oSender:Append()  //AddRow(Campos_aInsertLineBrow)
         oSender:Edit(oCol) // Para salir del modo edicion multiple y editar la columna actual
      //Else
      //   oSender:GoLeftMost() // Me posiciono en la primera columna para pasar EAN
      //EndIf

   ElseIf nKey == VK_F2
      If !oSender:IsOnEdit()
         oSender:Edit(oCol)
      EndIf

   ElseIf nKey <> VK_ESCAPE
   /*   If !Empty( cKey := VKeyToASCII( nKey, nFlags ) ) .AND. !oSender:IsOnEdit()
         oSender:Edit( oCol, nKey )
         //oCol:Edit( nKey )
         RETURN 0
      EndIf
      */

   EndIf

RETURN Nil

//------------------------------------------------------------------------------

METHOD BrowseMod1SaveCol( oSender, oCol, xValue ) CLASS TForm1
  Local nlinea, nColumna

   nlinea   := oSender:nIndex
   nColumna := IIF( oCol:IsKindOf( "TBrwColMod" ), oCol:nDataCol, oCol:oCol:nDataCol )

   If Len( oSender:aGridData ) < nlinea
      AAdd(oSender:aGridData,Campos_aInsertLineBrow)
   EndIf
   oSender:aGridData[ nlinea, nColumna ] := xValue
   If oSender:IsSingleEdit()
      PostMessage(oSender:Handle, WM_KEYDOWN, VK_RETURN)
   EndIf

RETURN Nil

//------------------------------------------------------------------------------
